#include <speex/speex_echo.h>
#include <stdio.h>
#include <malloc.h>
// $Id: speexecho.c,v 1.4 2004/08/24 11:52:08 ard Exp $
struct drft_lookup{
	int n;
	float *trigcache;
	int *splitcache;
};
/*
 * void drft_init(struct drft_lookup *l,int n)
 * { 
 *   l->n=n;
 *   l->trigcache=(float*)speex_alloc(3*n*sizeof(*l->trigcache));
 *   l->splitcache=(int*)speex_alloc(32*sizeof(*l->splitcache));
 *   fdrffti(n, l->trigcache, l->splitcache);
 * } 
 */
#define STATE_ENTRIES \
  STE(fft_lookup,1) \
  STE(fft_lookup->trigcache,3*N) \
  STE(fft_lookup->splitcache,32) \
  STE(x,N) \
  STE(d,N) \
  STE(y,N) \
  STE(X,M*N) \
  STE(D,N) \
  STE(Y,N) \
  STE(E,N) \
  STE(W,M*N) \
  STE(PHI,N) \
  STE(power,frame_size+1) \
  STE(power_1,frame_size+1) \
  STE(grad,N*M) \

int speex_echo_state_save(SpeexEchoState *st,FILE *file) {
	int frame_size,N,M;
	M=st->M;
	N=st->window_size;
	frame_size=st->frame_size;
	fwrite(st,sizeof(*st),1,file);
#define STE(element,n) fwrite(st->element,sizeof(*st->element),n,file); printf( "Writing " #element " %d elements = %d bytes\n", n, (n)*sizeof(*st->element));
	STATE_ENTRIES
#undef STE
	return 0;
}

SpeexEchoState *speex_echo_state_restore(FILE *file) {
	int frame_size,N,M;
	SpeexEchoState *st;
   	st = calloc(sizeof(*st),1);
	fread(st,sizeof(*st),1,file);
	M=st->M;
	N=st->window_size;
	frame_size=st->frame_size;
	
#define STE(element,n) \
		st->element=calloc(sizeof(*st->element),n); \
		printf( "Allocated " #element " %d elements = %d bytes @ %p\n", n, (n)*sizeof(*st->element),st->element); \
		printf( "Reading " #element " @%p %d elements = %d bytes\n", st->element, n, (n)*sizeof(*st->element)); \
		fread(st->element,sizeof(*st->element),n,file); \

	STATE_ENTRIES
#undef STE
	return st;
}

SpeexEchoState *loadEchoState() {
	FILE *f;
	SpeexEchoState *st;
	f=fopen("/var/run/foon.echostate","r");
	if(f) {
		printf("Loading echo state\n");
		st=speex_echo_state_restore(f);
		fclose(f);
	} else {
		printf("No echo state\n");
		st=NULL;
	}
	return st;
}

int saveEchoState(SpeexEchoState *st) {
	FILE *f;
	f=fopen("/var/run/foon.echostate","w");
	if(f) {
		printf("Writing echo state\n");
		speex_echo_state_save(st,f);
		fclose(f);
		return 0;
	} else {
		printf("Could not create echostatefile\n");
		return -1;
	}
}
